package com.fuzamei.service.serviceImpl;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.fuzamei.entity.Token;
import com.fuzamei.entity.User;
import com.fuzamei.mapperInterface.LoginMapper;
import com.fuzamei.service.LoginService;
import com.fuzamei.util.JSONUtil;
@Service
public class LoginServiceImpl implements LoginService{
	@Autowired
	private LoginMapper  loginMapper;
	
	@Transactional
	public Map<String,Object> login2(User user) {
       // TODO 检查用户的用户名、密码和随机数，能不能对应得上          ????????
		Map<String,Object> resultMap = new LinkedHashMap<String,Object>();
		List<User> userInfo = loginMapper.getUserCount(user);//待   待？？？
		resultMap = JSONUtil.getJsonMap(500, false, "账号登录失败", null);
		Token token1 = new Token();
		if(userInfo.size() == 1){
			String tokenRandom = UUID.randomUUID().toString().replace("-", "");
			//更新token
			token1.setUserId(user.getUserId());
			token1.setToken(tokenRandom);
			Token token = loginMapper.getTokenById(token1);
			if(token == null){
				int tokenCount = loginMapper.insertToken(token1);
				if(tokenCount != 1){
					throw new RuntimeException();
				}
			}
			else{
				int updateCount = loginMapper.updateToken(token1);
				if(updateCount != 1){
					throw new RuntimeException();
				}
			}
			
			resultMap = JSONUtil.getJsonMap(200, true, "账号登录成功", userInfo);
		}
		return  resultMap;
	}
	
	
	
	
	@Override
	public Token getTokenById(Token token) {
		
		return loginMapper.getTokenById(token);
	}

	@Override
	public int insertToken(Token token) {
		return loginMapper.insertToken(token);
	}

	@Override
	public int updateToken(Token token) {
		return loginMapper.updateToken(token);
	}

	@Override
	public List<User> getUserCount(User user) {
		return loginMapper.getUserCount(user);
	}
	
	
	
	
}
