package com.fuzamei.web;


import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.validation.FieldError;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.fuzamei.entity.User;
import com.fuzamei.entity.User.GroupA;
import com.fuzamei.service.LoginService;
import com.fuzamei.util.JSONUtil;

@RestController
@RequestMapping(path="/login")
public class LoginAction {

	@Autowired
	private LoginService loginService;
	
	@RequestMapping(path="/loginUserName")
	public Map<String,Object> loginUserName(@Validated(GroupA.class) @RequestBody User user,BindingResult result){
		Map<String,Object> resultMap = new LinkedHashMap<String,Object>();	//存放最终返回结果
		try {
			if(result.hasErrors()){
				List<FieldError> errors = result.getFieldErrors();
				resultMap = JSONUtil.getJsonMap(200, false, errors.get(0).getDefaultMessage(),null);
				return resultMap;
			}
			//resultMap =loginService.
		} catch (Exception e) {
			resultMap = JSONUtil.getJsonMap(200, false, "账号登录失败", null);
		}
		return resultMap;
	}
	
}
